#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <pwd.h>
#include <sys/stat.h>

#include <nhttpd.h>
#include <libhttpd.h>

config		conf;

int get_conf( int argc, char **argv, config *conf );

// get_conf    ϰ иѴ. 
int get_conf( int argc, char **argv, config *conf )
{
	int		c;		//getopt
	extern char	*optarg;	//getopt
	extern int	optind;		//getopt

	FILE		*fd;		// fd
	int		dummy;
	char	configname[1024];
	int		config_len;
	char	*configvalue;
	struct stat	filestat;

	optind = 1;

	conf->port =		_DEF_SET_PORT;
	conf->max_client =	_DEF_SET_MAX_CLIENT;
	conf->max_thread =	_DEF_SET_MAX_THREAD;
	conf->listen_backlog =	_DEF_SET_LISTEN_BACKLOG;
	conf->timeout =		_DEF_SET_TIMEOUT;

	conf->buf_size =	_DEF_SET_BUF_SIZE;
	conf->buf_size_max =	_DEF_SET_BUF_SIZE_MAX;

	conf->domain =		NEW( char, 1024 );
	gethostname( conf->domain, 1024 );

	conf->file_config =	NEW( char, 1024 );
	conf->file_config =	(char *) strncpy( conf->file_config, _DEF_SET_FILE_CONFIG, 1024 );
	conf->file_log =	NEW( char, 1024 );
	conf->file_log =	(char *) strncpy( conf->file_log, _DEF_SET_FILE_LOG, 1024 );
	conf->file_pid =	NEW( char, 1024 );
	conf->file_pid =	(char *) strncpy( conf->file_pid, _DEF_SET_FILE_PID, 1024 );
	conf->file_index =	NEW( char, 1024 );
	conf->file_index =	(char *) strncpy( conf->file_index, _DEF_SET_FILE_INDEX, 1024 );
	conf->document_root =	NEW( char, 1024 );
	conf->document_root =	(char *) strncpy( conf->document_root, _DEF_SET_DOCUMENT_ROOT, 1024 );
	conf->default_charset =	NEW( char, 1024 );
	conf->default_charset =	(char *) strncpy( conf->default_charset, _DEF_SET_CHARSET, 1024 );
	conf->server_user =	NEW( char, 1024 );
	conf->server_user =	(char *) strncpy( conf->server_user, _DEF_SET_SERVER_USER, 1024 );

	conf->error_page_400 =	NEW( char, 1024 );
	conf->error_page_400 =	(char *) strncpy( conf->error_page_400, _DEF_ERROR_PAGE_400, 1024 );
	conf->error_page_401 =	NEW( char, 1024 );
	conf->error_page_401 =	(char *) strncpy( conf->error_page_401, _DEF_ERROR_PAGE_401, 1024 );
	conf->error_page_403 =	NEW( char, 1024 );
	conf->error_page_403 =	(char *) strncpy( conf->error_page_403, _DEF_ERROR_PAGE_403, 1024 );
	conf->error_page_404 =	NEW( char, 1024 );
	conf->error_page_404 =	(char *) strncpy( conf->error_page_404, _DEF_ERROR_PAGE_404, 1024 );

	conf->use_vhost =	0;
	conf->use_gzip =	0;

	while ( (c = getopt(argc, argv, "c:h")) > 0 )
	{
		if ( c == 'c' )
		{
			conf->file_config = strncpy( conf->file_config, optarg, 1024 );
		}
		else if ( c == 'h' )
		{
			printf("Usage: nhttpd [-c configfile] [-N maxconnection] [-h]\n\nOptions:\n-c configfile\t\t: configfile path (ex: nhttpd.conf)\n-N maxconnects\t\t: max connection pool (ex: 256 or 512)\n-h\t\t\t: help (this screen)\n");
			return 0;
		}
	}

	dummy = stat( conf->file_config, &filestat );
	if ( dummy < 0 || (int) filestat.st_size < 2 )
		return -1;

	fd = fopen( conf->file_config, "r" );
	if ( fd == NULL )
		return -1;

        while ( fgets( configname, 1024, fd ) )
        {
		if ( configname[0] == '\n' || configname[0] == '\r' )
			continue;

		config_len = strlen( configname );
		if ( configname[config_len - 1] == '\r' || configname[config_len - 1] == '\n' )
			configname[config_len - 1] = '\0';
		if ( configname[config_len - 2] == '\r' || configname[config_len - 2] == '\n' )
			configname[config_len - 2] = '\0';

		if ( strncasecmp( configname, "HTTP_PORT", 9 ) == 0 )
		{
			configvalue = &configname[9];
			configvalue += strspn( configvalue, "=" );
			conf->port = atoi( configvalue );
		}
		else if ( strncasecmp( configname, "MAX_CLIENT", 10 ) == 0 )
		{
			configvalue = &configname[10];
			configvalue += strspn( configvalue, "=" );
			conf->max_client = MIN( _DEF_SET_MAX_THREAD, atoi( configvalue ) );
		}
		else if ( strncasecmp( configname, "MAX_THREAD", 10 ) == 0 )
		{
			configvalue = &configname[10];
			configvalue += strspn( configvalue, "=" );
			conf->max_thread = atoi( configvalue );
		}
		else if ( strncasecmp( configname, "LISTEN_BACKLOG", 14 ) == 0 )
		{
			configvalue = &configname[14];
			configvalue += strspn( configvalue, "=" );
			conf->listen_backlog = atoi( configvalue );
		}
		else if ( strncasecmp( configname, "TIMEOUT", 7 ) == 0 )
		{
			configvalue = &configname[7];
			configvalue += strspn( configvalue, "=" );
			conf->timeout = atoi( configvalue );
		}
		else if ( strncasecmp( configname, "BUF_SIZE", 8 ) == 0 )
		{
			configvalue = &configname[8];
			configvalue += strspn( configvalue, "=" );
			conf->buf_size = atoi( configvalue );
		}
		else if ( strncasecmp( configname, "BUF_SIZE_MAX", 12 ) == 0 )
		{
			configvalue = &configname[12];
			configvalue += strspn( configvalue, "=" );
			conf->buf_size_max = atoi( configvalue );
		}
		else if ( strncasecmp( configname, "FILE_LOG", 8 ) == 0 )
		{
			configvalue = &configname[8];
			configvalue += strspn( configvalue, "=" );
			memset( conf->file_log, 0x00, 1024 );
			memcpy( conf->file_log, configvalue, strlen( configvalue ) );
		}
		else if ( strncasecmp( configname, "FILE_PID", 8 ) == 0 )
		{
			configvalue = &configname[8];
			configvalue += strspn( configvalue, "=" );
			memset( conf->file_pid, 0x00, 1024 );
			memcpy( conf->file_pid, configvalue, strlen( configvalue ) );
		}
		else if ( strncasecmp( configname, "FILE_INDEX", 10 ) == 0 )
		{
			configvalue = &configname[10];
			configvalue += strspn( configvalue, "=" );
			memset( conf->file_index, 0x00, 1024 );
			memcpy( conf->file_index, configvalue, strlen( configvalue ) );
		}
		else if ( strncasecmp( configname, "DOCUMENT_ROOT", 13 ) == 0 )
		{
			configvalue = &configname[13];
			configvalue += strspn( configvalue, "=" );
			memset( conf->document_root, 0x00, 1024 );
			memcpy( conf->document_root, configvalue, strlen( configvalue ) );
		}
		else if ( strncasecmp( configname, "DEFAULT_CHARSET", 15 ) == 0 )
		{
			configvalue = &configname[15];
			configvalue += strspn( configvalue, "=" );
			memset( conf->default_charset, 0x00, 1024 );
			memcpy( conf->default_charset, configvalue, strlen( configvalue ) );
		}
		else if ( strncasecmp( configname, "SERVER_USER", 11 ) == 0 )
		{
			configvalue = &configname[11];
			configvalue += strspn( configvalue, "=" );
			memset( conf->server_user, 0x00, 1024 );
			memcpy( conf->server_user, configvalue, strlen( configvalue ) );
		}
		else if ( strncasecmp( configname, "ERROR_PAGE_400", 14 ) == 0 )
		{
			configvalue = &configname[14];
			configvalue += strspn( configvalue, "=" );
			memset( conf->error_page_400, 0x00, 1024 );
			memcpy( conf->error_page_400, configvalue, strlen( configvalue ) );
		}
		else if ( strncasecmp( configname, "ERROR_PAGE_401", 14 ) == 0 )
		{
			configvalue = &configname[14];
			configvalue += strspn( configvalue, "=" );
			memset( conf->error_page_401, 0x00, 1024 );
			memcpy( conf->error_page_401, configvalue, strlen( configvalue ) );
		}
		else if ( strncasecmp( configname, "ERROR_PAGE_403", 14 ) == 0 )
		{
			configvalue = &configname[14];
			configvalue += strspn( configvalue, "=" );
			memset( conf->error_page_403, 0x00, 1024 );
			memcpy( conf->error_page_403, configvalue, strlen( configvalue ) );
		}
		else if ( strncasecmp( configname, "ERROR_PAGE_404", 14 ) == 0 )
		{
			configvalue = &configname[14];
			configvalue += strspn( configvalue, "=" );
			memset( conf->error_page_404, 0x00, 1024 );
			memcpy( conf->error_page_404, configvalue, strlen( configvalue ) );
		}
        }

	fclose( fd );

	while ( (c = getopt(argc, argv, "N:")) > 0 )
	{
		switch ( c )
		{
			case 'N' :
				conf->max_client = atoi( optarg );
				break;
		}
	}

	return 0;
}
